/* Copyright (C) 1989 Aladdin Enterprises.  All rights reserved.
   Distributed by Free Software Foundation, Inc.

This file is part of Ghostscript.

Ghostscript is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY.  No author or distributor accepts responsibility
to anyone for the consequences of using it or for whether it serves any
particular purpose or works at all, unless he says so in writing.  Refer
to the Ghostscript General Public License for full details.

Everyone is granted permission to copy, modify and redistribute
Ghostscript, but only under the conditions described in the Ghostscript
General Public License.  A copy of this license is supposed to have been
given to you along with Ghostscript so you can know your rights and
responsibilities.  It should be in a file named COPYING.  Among other
things, the copyright notice and this notice must be preserved on all
copies.  */

/* gs.h */
/* Common definitions for GhostScript library */
#include <stdio.h>
#include "std.h"

/* Representation of point. */
typedef struct gs_point_s {
	float x, y;
} gs_point;

/* So many routines use the graphics state */
/* that we may as well declare the abstract type here. */
typedef struct gs_state_s gs_state;

/* A number of interfaces involve user-specified allocation */
/* and deallocation procedures, so we define the types here. */
typedef char *(*gs_proc_alloc)(P1(uint));
typedef void (*gs_proc_free)(P2(char *, uint));
typedef struct {
	gs_proc_alloc alloc;
	gs_proc_free free;
} gs_memory_procs;
/* We define our own versions of malloc and free that conform */
/* to the type just defined: */
char *gs_malloc(P1(uint));
void gs_free(P2(char *, uint));
